var Ger01800_UnidadeMedida_Controller = function(ScreenService, General,ZHPromise, Ger01800_UnidadeMedida_Service) {
	var firstLoad = true;
	var focus = false;
	var fieldToFocus = '#SGUNIDADE';
	
	this.filterConvByUnid = function(widget){
		if(widget.currentRow.__is_new){
			widget.container.getWidget('conversao').isVisible = false;
		}else{
			widget.container.getWidget('conversao').isVisible = true;		
			widget.container.getWidget('conversao').dataSourceFilter = [
				{
					"name": "SGUNIDADE",
					"operator": "=",
					"value": widget.currentRow.SGUNIDADE
				}
			];		
			widget.container.getWidget('conversao').reload();		
		}
	};

	this.onLoadDataSource = function (widget) {
		var rows = widget.dataSource.data;
		rows.forEach(function(row){
			row.MSG = row.VRFTCONVER + " " + row.DSUNIDPARA + " (s) equivale a 1 " + row.DSUNIDDE;
		});
	};
	
	this.triggerFocusField = function(widget){
		//ScreenService.showMessage("a");
		focus = true;
		widget.reload();	
	};
	
	this.focusField = function(widget) {
		if(focus) {
			if(firstLoad) {
				widget.reload();
				firstLoad = false;
			} else {
				document.querySelector(fieldToFocus).focus();	
				fieldToFocus = '#SGUNIDADE';
			}
		}
	};
	
	this.cancelAdd = function(args) {
		General.backOrCancel(args);
		focus = false;
	};
	
	this.saveAdd = function(widget) {
		General.saveCrud(widget).then(function() {
			ScreenService.goBack();
			widget.reload();	
		});
		focus = false;
	};
	
	this.editUnit = function(widget) {
		General.edit(widget);
		focus = true;
		fieldToFocus = '#DSUNIDADE';
		widget.reload();
	};
	
	this.onAddConvercao = function(widget){
		widget.newRow();
		widget.getField('RELACAOVALORES').dataSource = {};
		var currentRowUnidade = widget.container.getWidget('unidade').currentRow;
		widget.currentRow.SGUNIDDE = currentRowUnidade.SGUNIDADE;
		widget.currentRow.DSUNIDDE = currentRowUnidade.DSUNIDADE;
	};

	this.onChangeUnidConv = function(field) {
		if(field.value()){
			field.widget.getField('RELACAOVALORES').readOnly = false;
			field.widget.getField('VRFTCONVER').readOnly = false;
		}else{
			field.widget.getField('RELACAOVALORES').readOnly = true;
			field.widget.getField('VRFTCONVER').readOnly = true;	
		}
	};

	this.loadOpsRelacao = function(field){
		var currentRow = field.widget.currentRow;
		field.widget.getField('RELACAOVALORES').dataSource.data = [
			{
				"name": "dePara",
				"value": "1 "+ currentRow.DSUNIDDE +" equivale a "+ currentRow.DSUNIDPA + "(s)"
			},
			{
				"name": "paraDe",
				"value": "1 "+ currentRow.DSUNIDPA +" equivale a "+ currentRow.DSUNIDDE + "(s)"
			}
		];
	};

	this.prepVrFtConv = function(widget){
		if(widget.getField('RELACAOVALORES').value() === "dePara"){
			widget.currentRow.VRFTCONVER = General.valueToFloat(widget.currentRow.VRFTCONVER);
		}else{
			widget.currentRow.VRFTCONVER = this.roundFload(1 / (General.valueToFloat(widget.currentRow.VRFTCONVER)), 5);
		}
		widget.currentRow.IDTIPOPE = "*";
		General.saveCrud(widget).then(function(){
			widget.reload();
		});	
	};
	
	this.roundFload = function(value, decimals) {
		return Number(Math.round(value+'e'+decimals)+'e-'+decimals);
	};

	this.convView = function(widget){
		if(widget.currentRow.__is_new){
			// widget.getField('RELACAOVALORES').readOnly = true;
			widget.getField('VRFTCONVER').readOnly = true;
			widget.getField('DSUNIDPA').readOnly = false;
		}else{
			widget.currentRow.DSUNIDPA = widget.currentRow.DSUNIDPARA;
			widget.getField('RELACAOVALORES').dataSource.data = [
				{
					"name": "dePara",
					"value": "1 "+ widget.currentRow.DSUNIDDE +" equivale a "+ widget.currentRow.DSUNIDPA + "(s)"
				},
				{
					"name": "paraDe",
					"value": "1 "+ widget.currentRow.DSUNIDPA +" equivale a "+ widget.currentRow.DSUNIDDE + "(s)"
				}
			];
			// widget.getField('RELACAOVALORES').readOnly = false;
			widget.getField('VRFTCONVER').readOnly = false;
			widget.getField('DSUNIDPA').readOnly = true;
		}
		
	};
	
	this.excluirUnidade = function(widget){
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function(success) {
            Ger01800_UnidadeMedida_Service.excluirUnidMedida(widget.currentRow).then(function(){
				ScreenService.goBack();
				widget.reload();
				ScreenService.showMessage('Excluido com sucesso');
			});
    	});
	};
	
	this.validaRelacaoConv = function(field){
		var vrftconver = field.widget.currentRow.VRFTCONVER;
		if(vrftconver < 0.00001){
			ScreenService.showMessage('Relação (valor de x) deve ser maior que 0.00001');
		}
	};

};

Configuration(function(ContextRegister) {
	ContextRegister.register("Ger01800_UnidadeMedida_Controller", Ger01800_UnidadeMedida_Controller);
});