var Ger03800_ProdutosUnidade_Controller = function(ScreenService, General, templateManager, ZhFilterPreferences){
    var mensagens = {
        tempoMedio: 'O tempo médio de reposição deve estar entre 0 e 999.',
        unidadeNaoControlaEstoque: 'A unidade selcionada não controla estoque.',
        estoquePossuiSaldo : "Operação Bloqueada! Alteração requer que o produto seja zerado no estoque. É recomendado que antes de zerar o produto seja emitida a posição atual do mesmo na filial." 
    };
    
    this.getFilialLogada = function(){
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine( 'cadEst#/crud/filial', 'FilterData', filter);
    };
    
    this.openFilter = function(widget) {
        
        var defaultFilter = Util.clone(widget.currentRow);
        
        this.getFilialLogada().then(function(response) {
            var filial = response.dataset.filial[0];
            defaultFilter.CDFILIAL = filial.CDFILIAL;
            defaultFilter.NMFILIAL = filial.NMFILIAL;
            defaultFilter.IDCNTRESTOQ = "A";
            defaultFilter.IDPRODATIV = "T";
            ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(widget, defaultFilter).then(function(){
                var filtro = templateManager.container.getActiveWidget();
                this.validaFilial(filtro);
                widget.getField("NMPRODINI").reload();
            }.bind(this));
        }.bind(this)).catch(() => {
            ZhFilterPreferences.openFilterWidget(widget);
        });
        
    };
    
    this.validaFilial = function(widget) {
        if(widget.currentRow.NMFILIAL && widget.currentRow.CDFILIAL) {
            widget.getField('NMPRODINI').readOnly = false;
        }
        else {
            widget.getField('NMPRODINI').readOnly = true;
            widget.getField('NMPRODFIN').readOnly = true;
            widget.currentRow.NMPRODFIN   = '';
    		widget.currentRow.P_CDPRODFIN = '';
    		widget.currentRow.NMPRODINI   = '';
    		widget.currentRow.P_CDPRODINI = '';
        }
    };
    
    this.FilterProdIni = function(args){
		var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodIniIsSet = this.fieldIsSet(row.P_CDPRODINI);
        if(!prodIniIsSet) {
    		widget.currentRow.NMPRODFIN = '';
    		widget.currentRow.P_CDPRODFIN = '';
        	delete widget.getField('NMPRODINI').validations.required;
        	delete widget.getField('NMPRODFIN').validations.required;
        }
        else {
    	 widget.getField('NMPRODFIN').validations.required = true;
        }
        widget.getField('NMPRODFIN').readOnly = !prodIniIsSet;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !prodIniIsSet;
    };
    
    this.fieldIsSet = function(fieldValue) {
        if(fieldValue) return true;
        else return false;
    };
    
    this.reloadWidget= function(widget, field){
        widget.getField(field).reload();
    };
    

    this.FilterProdFin = function(args){
    	var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodFinIsSet = this.fieldIsSet(row.P_CDPRODFIN);
		if(prodFinIsSet) {
			widget.getField('NMPRODINI').validations.required = true;
            if(row.P_CDPRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
        } 
        else {
    		delete widget.getField('NMPRODINI').validations.required;
        }
        widget.reload();
    };

    this.openPopupCadastro = function(widget) {
        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICO');
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };
    
    this.openPopupCadastroProdFili = function(widget) {
        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICOPRODFILI');
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };
    
    this.ajustaFiltro = function(args, widget) {
        args.e.preventDefault();
    	if(!widget.appliedFilter.FILTER_ROW.P_CDPRODINI && !widget.appliedFilter.FILTER_ROW.P_CDPRODFIN) {
    		widget.dataSourceFilter[0].value = 'T';
            // widget.getParent().widgets[1].dataSourceFilter[0].value = 'T';
    	}
    	else {
    	    widget.dataSourceFilter[0].value = '';
    	    widget.dataSourceFilter[1].value = widget.appliedFilter.FILTER_ROW.P_CDPRODFIN;
    	    widget.dataSourceFilter[2].value = widget.appliedFilter.FILTER_ROW.P_CDPRODINI;
    	    
    	   // widget.getParent().widgets[1].dataSourceFilter[0].value = '';
    	   // widget.getParent().widgets[1].dataSourceFilter[1].value = widget.appliedFilter.FILTER_ROW.P_CDPRODFIN;
    	   // widget.getParent().widgets[1].dataSourceFilter[2].value = widget.appliedFilter.FILTER_ROW.P_CDPRODINI;
    
    	}
    	var newFilter = widget.dataSourceFilter.filter(f =>{
    	    if(!f.static && !(f.name == 'IDPRODATIV' && f.value == 'T'))
    	        return f;
    	});
    	widget.dataSourceFilter = newFilter;
    	widget.reload();
    };
    
    this.AjustaCtrEstoque = function(args){
        args.e.preventDefault();
        if(args.e.filters[1].value === "A"){
            let filter =  args.owner.dataSourceFilter.filter(param => { 
                if (param.name != "IDCNTRESTOQ"){
                    return true;
                   }else{
                       return false;
                   }
            });
            args.owner.dataSourceFilter = filter;
            args.owner.reload();
        }
    };
    
    this.saveCadastroAutomatico = function(widget) {

        var row = widget.currentRow;
        row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD',1).length;
        if(widget.isValid()) {
            General.callRestEngine('cadEst#/cadastroAutomaticoCtrlEstoq', 'Row', row).then(function(success){
                var widgetActivate = templateManager.container.getWidget('widgetProduto');
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICO');

                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                ScreenService.showMessage('Cadastrado com sucesso');
                widgetActivate.activate();
                widgetActivate.reload();

            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );


        }
    };
    
    this.saveCadastroAutomaticoProdFili = function(widget) {
        var row = widget.currentRow;
        
        for (var property in row){
            if(!row[property]){
                delete row[property];
            }
        }
        
        row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD',1).length;
        if(widget.isValid()) {
            General.callRestEngine('cadEst#/cadastroAutomaticoProdFili', 'Row', row).then(function(success){
                var widgetActivate = templateManager.container.getWidget('widgetProdFili');
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICOPRODFILI');
                    
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                ScreenService.showMessage('Operação realizada com sucesso');
                widgetActivate.activate();
                widgetActivate.reload();

            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.cancelarCadastroAutomaticoProdFili = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOMATICOPRODFILI');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('widgetProdFili');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };	
    
    this.saveProdFili = function(widget) {
        let percentFields = ["VRPTOLQTITAF", "VRPTOLVRITAF", "VRMINEMPENHOAF", "VRMINEMPENHOOL",  "VRPTOLAJUSINV"];
        percentFields.forEach(percentField => {
           let field = widget.getField(percentField);
           delete field.validations;
        });
        if(widget.isValid()) {
            validaValorPercentual(percentFields, widget);
        }
    };
    
    this.cancelarCadastroAutomaticoItem = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOMATICO');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('widgetProduto');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };	
    

    function validaValorPercentual(fields, widget) {
        var existeErro = false;
        var fieldsErro = fields.filter((field) => {
            if(widget.currentRow[field] && (widget.currentRow[field] < 0 || widget.currentRow[field] > 100)) 
                return field;
        });
        var mensagem = "Valor digitado não é um valor válido para o(s) campo(s): ";
        fieldsErro.forEach((field) => {
            mensagem += widget.getField(field).label + ",";
            existeErro = true;
        });
        if(existeErro) {
            mensagem = mensagem.substr(0,(mensagem.length - 1));
            ScreenService.showMessage(mensagem + "!");
            return false;
        }
        else {
            widget.dataSource.name = 'cadEst#/crud/prodporfili_produto';
            General.saveCrud(widget).then(success => {
                widget.dataSource.name = 'cadEst#/prodporfili_produto';
            });   
        }
    }
    
    this.changeDataSourceToSave = function(widget){
        widget.dataSource.name = 'cadEst#/crud/prodfili_produto_ctrlestq'; 
        General.saveCrud(widget).then(success => {
                widget.dataSource.name = 'cadEst#/prodfili_produto_ctrlestq';
            });
    };
    
    this.cancelarAtualizaProdFili = function() {
        var widget = templateManager.container.getWidget('ATUALIZAPRODFILI');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('widgetProdFili');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };
    
    this.openAtualizaProdFili = function(widget) {
        var widgetPopup = templateManager.container.getWidget('ATUALIZAPRODFILI');
        widgetPopup.newRow();
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };

    this.onChangeDestino = function(widget, lastChange, clearField) {
        var cdLastChange = "CD" + lastChange; 
        var nmLastChange = "NM" + lastChange;
        var cdClearField = "CD" + clearField;
        var nmClearField = "NM" + clearField;
        if(widget.currentRow[nmLastChange].length > 0) {
           if(widget.currentRow[nmClearField].length > 0) {
                widget.currentRow[cdClearField] = '';
                widget.currentRow[nmClearField] = '';
            } 
            widget.getField(nmClearField).validations = {};
            widget.getField(nmLastChange).validations = { required: true };
        }
        else if(widget.currentRow[nmClearField].length <= 0) {
            widget.getField(nmClearField).validations = { required: true };
            widget.getField(nmLastChange).validations = { required: true };
        } 
        else {
            widget.getField(nmClearField).validations = { required: true };
            widget.getField(nmClearField).validations = {};
        }
        
    };
    
    this.onChangeConfig = function(widget) {
        var nmListaParam = widget.getField("NMLISTAPARAM");
        if(widget.currentRow.IDTPCONFPAR == 1 || widget.currentRow.IDTPCONFPAR == 2) {
            nmListaParam.readOnly    = true;
            nmListaParam.validations = {};
        }  
        else {
            nmListaParam.readOnly    = false;
            nmListaParam.validations = { required: true};
        }
    };
    
    this.ctrlOnChange = function(widget){
        if(templateManager.container.getActiveWidget().name !== "zhFilterPreferencesSelectConditions" ){
            if(widget.row.IDCNTRESTOQ === "N"){
                this.verificaQntEstoque(widget).then(function(success){
                    if(success.dataset.qntEstoque_Produto.length > 0){
                    if(success.dataset.qntEstoque_Produto[0].QTESTOQDIA != "0"){
                        widget.row.IDCNTRESTOQ = "S";
                        ScreenService.showMessage(mensagens.estoquePossuiSaldo);
            }
                }
        }.bind(this));
             }
        }
    };
    
    this.verificaQntEstoque = function(widget){
       var filter = [
            {
                "name":"P_FILIAL",
                "operator":"=",
                "value": widget.row.CDFILIAL
            },
              {
                "name":"P_PRODFIN",
                "operator":"=",
                "value": widget.row.CDPRODUTO
            },
              {
                "name":"P_PRODINI",
                "operator":"=",
                "value": widget.row.CDPRODUTO
            }
        ];
        
       return General.callRestEngine('cadEst#/crud/qntEstoque_Produto', 'FilterData', filter);
    };
    
    
    this.atualizarProdFili = function(widget) {
      if(widget.isValid()) {
          if(widget.currentRow.P_CDPRODINI >  widget.currentRow.P_CDPRODFIN) {
              ScreenService.showMessage("Produto inicial deve ser menor ou igual que produto final.");
          }
          else if(widget.currentRow.CDFILIORIG == widget.currentRow.CDFILIDEST) {
              ScreenService.showMessage("Filial de origem deve ser diferente da filial de destino.");
          }
          else {
              General.callRestEngine('cadEst#/atualizaProdFili', 'Row', widget.currentRow).then(function(success){
                var widgetActivate = templateManager.container.getWidget('widgetProdFili');
                var widgetPopup = templateManager.container.getWidget('ATUALIZAPRODFILI');
                    
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                ScreenService.showMessage('Operação realizada com sucesso');
                widgetActivate.activate();
                widgetActivate.reload();

            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
          }
      }  
    };
    
    this.getFieldValueFilter = function(filedName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];
                    
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
    this.fixMetadata = function(args) {
        let columns = args.e.metadata.columns;
        $.each(columns, (column) => { 
            if(columns[column].format != undefined)
                if(columns[column].format.type == 'viewFloat')
                    columns[column].format.type = 'float';
        });
    };
    
    this.cleanFieldsOnChange = function(field){
        let widget = field.widget;
        let fieldProdIni = widget.getField('NMPRODINI');
        let fieldProdFim = widget.getField('NMPRODFIN');
        
        switch(field.name){
            case 'NMPRODFIN':
                widget.currentRow.P_CDPRODFIN = widget.currentRow.P_CDPRODFIN + "zzzzzzzzzzzzzzzzzzzzz";
                widget.currentRow.P_CDPRODFIN = widget.currentRow.P_CDPRODFIN.substring(0, 20);
                break;
            case 'NMPRODINI':
                fieldProdIni.validations = {"required": true};
                fieldProdFim.validations = {"required": true};
                break;
        }
        
    };
    
    this.validaMinMaxCampo = function(field){
        if(field.value() < 0 || field.value() > 100){
            ScreenService.showMessage('Valor deve ser entre 0 e 100%');
            var fieldName = field.name;
            field.value("");
            delete field.widget.currentRow[fieldName];
            field.reload();
        }
    };
    
    this.setOldControlsOnRow = function(widget){
        let arrFieldsToStore = ['IDCNTRESTOQ', 'IDUTCTRLLOTE'];
        arrFieldsToStore.forEach(field => widget.currentRow['old_'+field] = widget.currentRow[field]);
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Ger03800_ProdutosUnidade_Controller', Ger03800_ProdutosUnidade_Controller);
});