function Ger09900_AgrupamentoDeProdutos_Controller(restEngine, ScreenService, General, Ger09900_AgrupamentoDeProdutos_Service, templateManager, ZhFilterPreferences) {



    this.moveRowSubGrupo = function(widget) {
        if (widget.mode == 'list') {
            General.buildDataSourceFilter(widget.dataSourceFilter, {
                CDGRUPPROD: widget.getParent().currentRow.CDGRUPPROD,
                CDFILISUBGR: "P"
            });
            if (widget.name == 'subGrupoFilial') {
                var filter = [{
                    "name": "CDGRUPPROD",
                    "operator": "=",
                    "value": widget.getParent().currentRow.CDGRUPPROD
                }];
                widget.getField('NMSUBGRPROD').dataSourceFilter = filter;
            }
            else {
                widget.getField('NMSUBGRPROD').dataSourceFilter = [];
            } 
            widget.getField('NMSUBGRPROD').reload();
            widget.reload();
        }
        
        let widgetProdutoSubGrupo = templateManager.container.getWidget("produtoSubGrupo");
        
        if(widget.currentRow.__is_new){
            widgetProdutoSubGrupo.isVisible=false;
        }else{
            widgetProdutoSubGrupo.isVisible=true;
        }
        
    };

    this.addProduto = function(widget) {
        if (widget.dataSource.data.length < widget.getParent().currentRow.NRMAXITSUBGR) {
            widget.newRow();
        }
        else {
            ScreenService.showMessage("Operação bloqueada. O número de produtos cadastrados excede número máximo permitido.");
        }
    };

    this.moveRowProduto = function(widget) {
        if (widget.mode == 'list') {

            var CDGRUPPROD = widget.getParent().currentRow.CDGRUPPROD;
            var CDSUBGRPROD = widget.getParent().currentRow.CDSUBGRPROD;
            var CDFILISUBGR = widget.getParent().currentRow.CDFILISUBGR;
            
            General.buildDataSourceFilter(widget.dataSourceFilter, {
                CDGRUPPROD: CDGRUPPROD,
                CDSUBGRPROD: CDSUBGRPROD,
                CDFILISUBGR: (widget.name == 'produtoSubGrupoFilial') ? CDFILISUBGR : "P"
            });
            if (widget.getParent().getParent().currentRow.IDCADNVSUBGR == 'N') {
                var filter = [{
                    "name": "CDNVPRODUTO",
                    "operator": "=",
                    "value": General.getLevelByMask('GER_CDPICTPROD', 1).length
                }];

                widget.getField('NMPRODUTO').dataSourceFilter = filter;
            }
            else {
                widget.getField('NMPRODUTO').dataSourceFilter = [];
            }
            widget.getField('NMPRODUTO').reload();
            widget.reload();
        }
    };

    this.saveGrupo = function(widget) {

        if (widget.currentRow.IDCADNVSUBGR == 'N') {
            var filter = [{
                    "name": "CDGRUPPROD",
                    "value": widget.currentRow.CDGRUPPROD,
                    "operator": "="
                },
                {
                    "name": "CDNVPRODUTO",
                    "value": General.getLevelByMask('GER_CDPICTPROD', 1).length,
                    "operator": "<"
                }

            ];
            Ger09900_AgrupamentoDeProdutos_Service.verificaProdutos(filter).then(function(callback) {
                var dataset = callback.dataset.produto_nvsubgrprod;
                if (!dataset.length) {
                    General.saveCrud(widget);
                }
                else {
                    ScreenService.showMessage("Operação bloqueada. Existe produto de nível incompleto cadastrado.");
                    widget.currentRow.IDCADNVSUBGR = 'S';
                }
            });
        }
        else {
            General.saveCrud(widget);
        }
    };

    this.saveSubGrupo = function(widget) {
        if (widget.isValid()) {
            var data = [];
            var row = widget.currentRow;
            row.CDGRUPPROD = widget.getParent().currentRow.CDGRUPPROD;
            if (widget.name != 'subGrupoFilial') {
                row.CDFILISUBGR = 'P';
            }

            data.push(row);
            Ger09900_AgrupamentoDeProdutos_Service.saveSubGrupo(data).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    this.saveProduto = function(widget) {
        if (widget.isValid()) {
            var data = [];
            var row = widget.currentRow;
            row.CDGRUPPROD = widget.getParent().getParent().currentRow.CDGRUPPROD;
            row.CDSUBGRPROD = widget.getParent().currentRow.CDSUBGRPROD;
            row.CDFILISUBGR = (widget.getParent().name == 'subGrupoFilial') ? widget.getParent().currentRow.CDFILISUBGR : 'P';
            row.CDNVPRODUTO = General.getLevelByMask('GER_CDPICTPROD', 1).length;
            data.push(row);
            Ger09900_AgrupamentoDeProdutos_Service.saveProduto(data).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    this.deleteGrupo = function(widget) {
        ScreenService.confirmMessage("O grupo de produtos selecionado será excluído. Confirma a exclusão do grupo, seus sub-grupos e todos os produtos já cadastrados?", 'question', function() {
            Ger09900_AgrupamentoDeProdutos_Service.deleteGrupo([widget.currentRow]).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(error) {
                if(error.data.error.includes("ORA-02292")){
                    ScreenService.showMessage("Operação bloqueada! Agrupamento já associado a Implantação ou Ajuste de inventário.");
                }else{
                    ScreenService.showMessage(error.data.error);
                }
            });
        });
    };

    this.deleteSubGrupo = function(widget) {
        ScreenService.confirmMessage("O sub-grupo de produtos selecionado será excluído. Confirma a exclusão do sub-grupo e todos os produtos já cadastrados?", 'question', function() {
            Ger09900_AgrupamentoDeProdutos_Service.deleteSubGrupo([widget.currentRow]).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    this.deleteProduto = function(widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function(success) {
            widget.currentRow.NVMAXPRODUTO = General.getLevelByMask('GER_CDPICTPROD', 1).length;
            Ger09900_AgrupamentoDeProdutos_Service.deleteProduto([widget.currentRow]).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            });
        });
    };
    
    this.hideWidgetsOnGrupo = function(widget){
        let widgetSubGrupo = templateManager.container.getWidget("subGrupo");
        let widgetCongUnidade = templateManager.container.getWidget("subGrupoFilial");
        
        if(widget.currentRow.__is_new){
            widgetSubGrupo.isVisible=false;
            widgetCongUnidade.isVisible=false;
        }else{
            widgetCongUnidade.isVisible=true;
            widgetSubGrupo.isVisible=true;
        }
        
    };
    
    this.openFilter = function(widget) {
        
        this.setFieldsGerais(widget);
        let rowsToSet  = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILISUBGR = [success.dataset.filial[0].CDFILIAL];
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            ZhFilterPreferences.openFilterWidget(widget,rowsToSet).then(function(success) {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
            }.bind(this));
        }.bind(this));
        
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.getFilialLogada = function() {
    var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
    return General.callRestEngine('cadEst#/crud/filial', 'FilterData', filter);
    };
    
    this.integerFields = function(widget){
        let codigo = widget.getField('CDSUBGRPROD');
        let nrMax = widget.getField('NRMAXITSUBGR');
        
        General.justInteger('#CDSUBGRPROD');
        codigo.reload();
        General.justInteger('#NRMAXITSUBGR');
        nrMax.reload();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger09900_AgrupamentoDeProdutos_Controller', Ger09900_AgrupamentoDeProdutos_Controller);
});
