function Ger14600_ComposicaoDoProduto_Controller(Ger14600_ComposicaoDoProduto_Service, ScreenService, General, templateManager, ZhFilterPreferences, ZHPromise, restEngine) {

	var mensagens = {
		Porcentagem: 'O Valor do desconto(%) deve ser um valor entre 0 e 100',
		Delete: 'Deletado com sucesso!',
		SaveInstrucao: 'Instrução salva com sucesso!',
		Quantidades: "Quantidade Mínima deve ser menor ou igual a Quantidade Máxima.",
		ProdutoObrigatorio: "O Produto Obrigatório só pode ser 'Sim' para produtos que estiver Pré-Selecionado como 'Sim'.",
		valorDesconto: "O Valor Desconto de ser maior ou igual a 0 (zero).",
		MaiorQueZero: "A Quantidade deve ser maior ou igual a 0 (zero).",
		ComposicaoRecursiva: "Não é possível adicionar o produto na sua própria composição!",
		ErroData: "A data final deve ser maior que a data inicial!"
	};

	const PROMOCAO_COMBINADA_VALUE = '3';
	const NRCOMPPRODFLAG = 'NRCOMPPRODFLAG';

	this.openFilter = function (widget) {
		var defaultFilter = Util.clone(widget.currentRow);

		General.callRestEngine("cadEst#/crud/filial", "FilterData", [{ name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA" }]).then(function (response) {
			defaultFilter.CDFILIAL = response.dataset.filial[0].CDFILIAL;
			defaultFilter.NMFILIAL = response.dataset.filial[0].NMFILIAL;
			defaultFilter.NRCOMPPRODFLAG = 'T';
			defaultFilter.IDTIPOCOMPPR = '_0_1_2_3_4_5_6_';
			defaultFilter.NMTIPOCOMPPR = '_0_1_2_3_4_5_6_';
			ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
			ZhFilterPreferences.openFilterWidget(widget, defaultFilter);
		}).catch(() => {
			ZhFilterPreferences.openFilterWidget(widget);
		});

	};

	this.saveComposicao = function (widget) {
		var row = widget.currentRow;
		resetFilterValidations(widget);
		row.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		row.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
		General.saveCrud(widget).then(() => {
			General.changeWidgetAcessibility(widget.widgets, true);
		});
	};

	this.deleteFilhos = function (widget) {
		// Deleta Registros filhos
		var row = widget.currentRow;
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			Ger14600_ComposicaoDoProduto_Service.deletaFilhos(row).then(function (response) {
					ScreenService.showMessage(mensagens.Delete);
					ScreenService.closeSwipe();
					widget.reload();

				},
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		});

	};

	this.deleteCrudCheckedRows = function (widget) {
		var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Deletar registros selecionados?'), 'question', function (success) {
			widget.removeCheckedRows().then(function () {
				widget.reload();
				widget.unSelectAll();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O(s) registro(s) possui(em) registros filhos.');
				}
				else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
	};
	// ----------------------PRODUTO-----------------------------//

	this.fieldOnChangeTipoFiltro = function (widget) {
		if (widget.currentRow.TIPOFILTRO === 'S') {

			widget.getField('NMPRODINI').isVisible = false;
			widget.getField('NMPRODFIN').isVisible = false;
			widget.getField('CDPRODUTO').isVisible = false;
			widget.currentRow.CDPRODUTO = 'S';
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_PRODFIN = '';
			widget.currentRow.NMPRODINI = '';
			widget.currentRow.P_PRODINI = '';
		}
		else if (widget.currentRow.TIPOFILTRO === 'L') {
			widget.getField('NMPRODINI').isVisible = false;
			widget.getField('NMPRODFIN').isVisible = false;
			widget.getField('CDPRODUTO').isVisible = true;
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_PRODFIN = '';
			widget.currentRow.NMPRODINI = '';
			widget.currentRow.P_PRODINI = '';
		}
		else if (widget.currentRow.TIPOFILTRO === 'I') {
			widget.getField('CDPRODUTO').isVisible = false;
			widget.getField('NMPRODINI').isVisible = true;
			widget.getField('NMPRODFIN').isVisible = true;
			widget.currentRow.P_PRODINI = '';
			widget.currentRow.P_PRODFIN = '';
			widget.currentRow.CDPRODUTO = 'I';
		}
		widget.reload();
	};

	this.fieldOnChangeProdutoLista = function (widget) {
		if (!widget.currentRow.__is_new) {
			// Concatena os dados do vetor de CDPRODUTO em uma string
			var vetorCDPRODUTO = widget.currentRow.CDPRODUTO;
			widget.currentRow.CDPRODUTOS = vetorCDPRODUTO.join('_');
		}
	};

	this.fieldOnChangeComposicao = function (widget) {
		// Concatena os dados do vetor de NMTIPOCOMPPR em uma string(IDTIPOCOMPPR)
		var count = 0;
		var vetorComposicao = widget.currentRow.NMTIPOCOMPPR;
		for (count = 0; count < vetorComposicao.length; count += 2) {
			if (count === 0) {
				widget.currentRow.IDTIPOCOMPPR = '_' + vetorComposicao[0] + '_';
			}
			else {
				widget.currentRow.IDTIPOCOMPPR = widget.currentRow.IDTIPOCOMPPR.concat(vetorComposicao[count] + '_');
			}
		}
	};

	this.fieldOnChangeSegmento = function (widget) {
		if (!widget.currentRow.CDSEGMER) {
			widget.currentRow.CDSEGMER = 'T';
		}
	};

	this.ajustaFiltroProduto = function (args, widget) {
		args.e.preventDefault();
		// Ajusta os valores do filtro
		var filterPopup = widget.appliedFilter.FILTER_ROW;
		var filters = [];
		var idtipocomp = false;
		widget.dataSourceFilter = widget.dataSourceFilter.map(function (row) {
			var filter = { name: '', operator: '=', value: '' };
			switch (row.name) {
			case 'NMTIPOCOMPPR':
				filter.name = 'NMTIPOCOMPPROD';
				var NMTIPOCOMPPROD = (typeof (filterPopup.NMTIPOCOMPPR) == 'object') ? filterPopup.NMTIPOCOMPPR.join('_') : '_0_1_2_3_4_5_6_';
				filter.value = NMTIPOCOMPPROD;
				filters.push(filter);
				idtipocomp = true;
				break;

			case 'CDFILIAL':
				filter.name = 'CDFILIAL';
				filter.value = filterPopup.CDFILIAL;
				filters.push(filter);
				break;

			case 'TIPOFILTRO':
				var TODOS = filterPopup.TIPOFILTRO || 'T';
				filter.value = 'T';
				filter.name = 'TODOS';
				filters.push(filter);
				break;

			case 'NRCOMPPRODFLAG':
				filter.name = 'NRCOMPPRODFLAG';
				filter.value = filterPopup.NRCOMPPRODFLAG;
				filters.push(filter);
				break;

			case 'P_PRODINI':
				filter.name = row.name;
				var P_PRODINI = filterPopup.P_PRODINI || null;
				filter.value = P_PRODINI;
				filters.push(filter);
				break;

			case 'P_PRODFIN':
				// Completa o filtro com zzz quando o tipo de filtro for intervalo
				var P_PRODFIN = filterPopup.P_PRODFIN || 'zzzzzzzzzzzzzzzzzzzz';
				if (P_PRODFIN !== 'zzzzzzzzzzzzzzzzzzzz') {
					var vetorPRODFIN;
					var mask = getLocalVar('CDPICTPROD');
					mask = mask.replace(/\./g, '');
					vetorPRODFIN = P_PRODFIN.padEnd(mask.length, 'z');

					P_PRODFIN = vetorPRODFIN.toString();
					P_PRODFIN = P_PRODFIN.replace(/\,/g, '');
				}
				filter.name = row.name;
				filter.value = P_PRODFIN;
				filters.push(filter);
				break;

			case 'CDPRODUTO':
				var CDPRODUTO = filterPopup.CDPRODUTO || 'S';
				if (CDPRODUTO !== 'S' && CDPRODUTO !== 'I') {
					filter.value = filterPopup.CDPRODUTOS;

				}
				else(filter.value = CDPRODUTO);

				filter.name = row.name;
				filters.push(filter);
				break;

			case 'CDNVPRODUTO':
				var CDNVPRODUTO = General.getLevelByMask('CDPICTPROD', 1).length;
				filter.name = row.name;
				filter.value = CDNVPRODUTO;
				filters.push(filter);
				break;

			case 'CDSEGMER':
				filter.name = row.name;
				var CDSEGMER = filterPopup.CDSEGMER || 'T';
				filter.value = CDSEGMER;
				filters.push(filter);
				break;
			}
		});
		if (!idtipocomp) {
			var filter = { name: 'NMTIPOCOMPPROD', operator: '=', value: '_0_1_2_3_4_5_6_' };
			filters.push(filter);
		}
		widget.dataSourceFilter = filters;
		widget.reload();
	};

	this.prodIni = function (widget) {
		var row = widget.currentRow;
		widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
		widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
		row.NMPRODFIN = '';
		this.prodFin(widget);
	};

	this.prodFin = function (widget) {
		var row = widget.currentRow;
		widget = widget.container.getWidget('PRODUTO');
		widget.getField('NMPRODFIN').dataSourceFilter[0].value = row.P_PRODINI;
		widget.getField('NMPRODFIN').reload();
	};

	this.saveProdutoPromocional = function (widget) {

		if (widget.isValid()) {
			widget.currentRow.CDGRUPROMOC = widget.getParent().currentRow.CDGRUPROMOC;
			General.saveCrud(widget);
		}
	};

	this.removeFilterValidations = function (widget) {
		widget.getField(NRCOMPPRODFLAG).validations = false;
	};

	var resetFilterValidations = function (widget) {
		widget.getField(NRCOMPPRODFLAG).validations = true;
	};

	// ----------------------PRODUTO-----------------------------//

	// ---------------------COMPOSIÇÃO---------------------------//

	this.reloadField = function () {
		templateManager.container.getActiveWidget().reload();
	};

	this.checkVigenciaAndSave = function (widget, local) {
		var DTINIVG, DTFINVG, CDGRUPRO;
		if (local) {
			DTINIVG = 'DTINIVGGRPROFIL';
			DTFINVG = 'DTFINVGGRPROFIL';
			CDGRUPRO = 'CDGRUPROMOC';
		}
		else {
			DTINIVG = 'DTINIVGGRPROMO';
			DTFINVG = 'DTFINVGGRPROMO';
			CDGRUPRO = 'CDGRUPROMOC';
		}

		if (widget.currentRow.DTINIVGGRPROMO) {
			var rows = widget.dataSource.data.filter(f => ((!f.__is_new) && f.CDGRUPROMOC == widget.currentRow.CDGRUPROMOC && f.NRSEQGRPROMO != widget.currentRow.NRSEQGRPROMO));
			var flag = true;
			var currentVigIni = new Date(moment(widget.currentRow.DTINIVGGRPROMO, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();
			var currentVigFin = new Date(moment(widget.currentRow.DTFINVGGRPROMO, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();
			rows.forEach(row => {

				var vigIni = new Date(moment(row.DTINIVGGRPROMO, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();
				var vigFin = new Date(moment(row.DTFINVGGRPROMO, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();

				if (currentVigIni <= vigFin && currentVigFin >= vigIni) {
					flag = false;
				}
				else if (currentVigIni >= vigFin && currentVigFin <= vigIni) {
					flag = false;
				}
			});
			if (!flag) {
				ScreenService.showMessage('Data de vigência inválida');
			}
			else {
				this.save(widget);
			}
		}
		else {
			this.save(widget);
		}
	};


	this.save = function (widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			row.NRORG = getLocalVar('NRORG');
			var parentRow = widget.getParent().getParent().currentRow;
			// CDPRODUTO -> Usado para salvar um grupo de composição
			row.CDPRODUTO = parentRow.CDPRODUTO;

			if ((row.CDARVPROD + "").replace(/\./g, "") === (parentRow.CDARVPROD + "").replace(/\./g, "")) {
				ScreenService.showMessage(mensagens.ComposicaoRecursiva);
			}
			else {
				if (!Util.isUndefinedOrNull(row.QTSUBPRODROT)) {
					row.QTSUBPRODROT += '';
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(/\./g, '');
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(',', '.');
					row.QTSUBPRODROT = parseFloat(row.QTSUBPRODROT);
				}

				// CDPRODPROMOCAO -> Usado para salvar um produto de um grupo promocional
				if (!Util.isUndefinedOrNull(row.CDGRUPROMOC)) {
					row.CDPRODPROMOCAO = parentRow.CDPRODUTO;
					var menor = parseFloat(row.QTPRGRUPROMIN),
						maior = parseFloat(row.QTPRGRUPPROMOC);
					if (!validaQuantidades(menor, maior)) return;
					///VALIDA DATA////
					if (widget.getField('DTFINVGGRPROMO').value()) {

						if (widget.getField('DTINIVGGRPROMO').value()) {

							if (!self.compareDates(widget.currentRow.DTINIVGGRPROMO, widget.currentRow.DTFINVGGRPROMO) &&
								widget.currentRow.DTINIVGGRPROMO !== widget.currentRow.DTFINVGGRPROMO) {
								ScreenService.showMessage(mensagens.ErroData);
							}
							else {
								General.saveCrud(widget);
							}

						}
						else {
							General.saveCrud(widget);
						}
					}
					else {
						General.saveCrud(widget);
					}


				}
				else {

					var parentWidget = widget.getParent().getParent();

					var requestRow = {
						'CDPRODUTOPAI': parentWidget.currentRow.CDPRODUTO,
						'CDPRODUTOFILHO': row.CDARVPROD,
						'CDFILIAL': parentWidget.appliedFilter.FILTER_ROW.CDFILIAL
					};

					General.callRestEngine('cadEst#/checkForRecursiveComposition', 'Row', requestRow).then(function (response) {
						if (!!response.dataset.isRecursiveComposition[0]) {
							ScreenService.showMessage(mensagens.ComposicaoRecursiva);
						}
						else {
							General.saveCrud(widget).then(function () {
								widget.currentRow.changed = false;
							});
						}
					});
				}
			}
		}
	};

	var validaQuantidades = function (menor, maior) {
		if (maior < menor) {
			ScreenService.showMessage(mensagens.Quantidades);
			return false;
		}
		if (maior < 0 || menor < 0) {
			ScreenService.showMessage(mensagens.MaiorQueZero);
			return false;
		}
		return true;
	};

	this.updateFilter = function (widget) {
		if (!widget.currentRow.NMFILIAL) {
			templateManager.container.getWidget('INSTRUCOESLOCAL').enabled = false;
			templateManager.container.getWidget('INSTRUCOESLOCAL').enabled = false;
		}
		else {
			templateManager.container.getWidget('INSTRUCOESLOCAL').enabled = true;
			templateManager.container.getWidget('INSTRUCOESLOCAL').enabled = true;
		}
		templateManager.container.getWidget('COMPOSICAOLOCAL').reload();
		templateManager.container.getWidget('GRUPOPROMOCIONALLOCAL').reload();
		templateManager.container.getWidget('INSTRUCOESLOCAL').reload();

	};

	this.saveInstrucao = function (widget) {
		// Verifica se a tabela possui dados
		// Seta o __is_new
		// Salva o as instruções
		var cdProduto = widget.getParent().getParent().currentRow.CDPRODUTO;
		var widgetName = widget.name;
		var rota;
		if (widgetName === 'INSTRUCOES') rota = 'cadEst#/crud/descroteiro';
		else rota = 'cadEst#/crud/descrotlocal';

		var row = {
			CDPRODUTO: cdProduto,
			ROTA: rota,
			CDFILIAL: widget.getParent().currentRow.CDFILIAL
		};

		if (rota === 'cadEst#/crud/descroteiro') {
			// Salva a Instrução
			widget.currentRow.CDPRODUTO = cdProduto;
			Ger14600_ComposicaoDoProduto_Service.saveBlob(widget.currentRow).then(function (success) {
				widget.activate();
				if (widget.currentRow.__is_new) {
					widget.edit();

					widget.reload();
					widget.computeDescriptionOrder();
					widget.view();

				}
				delete widget.currentRow.CDPRODUTO;
				ScreenService.showMessage(mensagens.SaveInstrucao);
				widget.list();
				widget.template = widget.templateToView;
				templateManager.updateTemplate();
			}, function (error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = error.data.error;
				}
				ScreenService.showMessage(errorMessage);

			});
		}
		else if (rota === 'cadEst#/crud/descrotlocal') {
			// Salva a Instrução
			widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDCOMPOSICAOLOCAL').currentRow.CDFILIAL;
			widget.currentRow.CDPRODUTO = cdProduto;
			Ger14600_ComposicaoDoProduto_Service.saveBlob(widget.currentRow).then(function (success) {
				widget.activate();
				if (widget.currentRow.__is_new) {
					widget.reload();
					widget.computeDescriptionOrder();
					widget.view();
					delete widget.currentRow.CDPRODUTO;
				}
				widget.list();
				widget.template = widget.templateToView;
				templateManager.updateTemplate();
			}, function (error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = error.data.error;
				}
				ScreenService.showMessage(errorMessage);

			});
		}
	};

	this.filtraInstrucoes = function (widget) {

		var widgetToFilter = templateManager.container.getWidget('INSTRUCOES');
		var widgetToFilter2 = templateManager.container.getWidget('INSTRUCOESLOCAL');

		Ger14600_ComposicaoDoProduto_Service.setDataSourceFilter(widget, widgetToFilter);
		Ger14600_ComposicaoDoProduto_Service.setDataSourceFilter(widget, widgetToFilter2);

	};

	this.setFormInstrucoes = function (widget) {
		// Coloca no form os dados do dataSource
		if (widget.name === 'INSTRUCOES') {
			if (widget.dataSource.data[0]) widget.currentRow.TXROTFAB = widget.dataSource.data[0].TXROTFAB;
			else widget.currentRow.TXROTFAB = '';
		}
		else {
			if (widget.dataSource.data[0]) widget.currentRow.TXROTFABLOC = widget.dataSource.data[0].TXROTFABLOC;
			else widget.currentRow.TXROTFABLOC = '';
		}
	};

	//---------------GRUPO PROMOCIONAL---------------------//
	this.setValidationValuePadrao = function (widget) {
		// Torna o campo de valor desconto obrigatorio quando IDPERVALORDES tem valor e deixa indisponivel o campo valor quando os campos desconto/acrecimo e valor/percentual nao estao selecionados alem de limpar o campo valor nesses casos

		if (widget.currentRow.IDPERVALORDES || widget.currentRow.IDDESCACRPROMO) {
			widget.getField('VRDESPRODPROMOC').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDDESCACRPROMO').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDOBRPRODSELEC').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDPERVALORDES').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('VRDESPRODPROMOC').readOnly = false;
		}
		else {
			widget.getField('VRDESPRODPROMOC').readOnly = true;
			delete widget.currentRow.$error;
			widget.currentRow.VRDESPRODPROMOC = null;
			widget.getField('VRDESPRODPROMOC').validations = {};
			widget.getField('IDDESCACRPROMO').validations = {};
			widget.getField('IDPERVALORDES').validations = {};
			widget.getField('IDOBRPRODSELEC').validations = {};
			templateManager.updateTemplate();






		}

	};

	this.setValidationValue = function (widget) {
		// Torna o campo de valor desconto obrigatorio quando IDPERVALORDES tem valor e deixa indisponivel o campo valor quando os campos desconto/acrecimo e valor/percentual nao estao selecionados alem de limpar o campo valor nesses casos
		if (widget.currentRow.IDPERVALDESFIL || widget.currentRow.IDDESCACRPROFIL) {
			widget.getField('VRDESPRPROMOFIL').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDDESCACRPROFIL').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDOBRPRODSELFIL').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};
			widget.getField('IDPERVALDESFIL').validations = {
				"required": {
					"message": "Campo Obrigatorio"

				}
			};

			widget.getField('VRDESPRPROMOFIL').readOnly = false;
		}
		else {
			widget.getField('VRDESPRPROMOFIL').readOnly = true;
			widget.currentRow.VRDESPRPROMOFIL = null;
			delete widget.currentRow.$error;
			widget.getField('VRDESPRPROMOFIL').validations = {};
			widget.getField('IDDESCACRPROFIL').validations = {};
			widget.getField('IDPERVALDESFIL').validations = {};
			widget.getField('IDOBRPRODSELFIL').validations = {};
			templateManager.updateTemplate();
		}
	};

	this.fieldOnChangeVrDesconto = function (widget) {
		// Verifica se o valor desconto esta entre 0 e 100 se IDPERVALORDES for porcentagem
		if (widget.currentRow.IDPERVALORDES === 'P' &&
			(parseInt(widget.currentRow.VRDESPRODPROMOC) >= 100 || parseInt(widget.currentRow.VRDESPRODPROMOC) <= 0)) {
			ScreenService.showMessage(mensagens.Porcentagem);
			widget.currentRow.VRDESPRODPROMOC = '';
		}
	};

	this.saveProdutoPromocionalComposicao = function (widget) {
		// Salva um produto promocional dentro da aba Composição
		var validProdPrinMax = self.validProdPrinMax(widget.currentRow);
		if (widget.isValid() && validProdPrinMax) {
			if (!validacoesProdutoPromocionalComposicao(widget.currentRow)) return;
			//	widget.currentRow.__is_new = Util.isUndefinedOrNull(widget.currentRow.CDPRODPROMOCAO);
			//	widget.currentRow.changed = !widget.currentRow.__is_new;
			widget.currentRow.CDGRUPROMOC = widget.getParent().currentRow.CDGRUPROMOC;
			widget.currentRow.NRSEQGRPROMO =
				Util.isUndefinedOrNull(widget.currentRow.NRSEQGRPROMO) ? widget.getParent().currentRow.NRSEQGRPROMO : widget.currentRow.NRSEQGRPROMO;
			widget.currentRow.IDPERVALORDES =
				Util.isUndefinedOrNull(widget.currentRow.IDPERVALORDES) ? 'P' : widget.currentRow.IDPERVALORDES;
			widget.currentRow.CDPRODPROMOCAO = widget.getParent().getParent().getParent().currentRow.CDPRODUTO;
			General.saveCrud(widget).then(function () {
				if (!widget.currentRow.__is_new) {
					ScreenService.closeSwipe();
				}
				widget.reload().then(function (response) {
					self.validProdPrinMin(response.dataset, true);
				});
			});
		}

	};

	this.validProdPrinMax = function (row) {
		var retorno = true;
		if (row.QTPRGRUPPROMOC == row.IDPRINCPRODQT && row.IDPRINCPROD == 'S' && row.IDPRINCPROD != row.IDPRINCPRODBKP) {
			ScreenService.showMessage('Quantidade de produtos principais superior a quantidade de produtos maxima.');
			retorno = false;
		}
		return retorno;
	};

	this.validProdPrinMin = function (dataset, padrao) {
		var datasourceName = padrao ? 'desgrupromocpr_prodgrupromoc_produto' : 'desgrupromprfil_prodgrupromoc_produto';

		if (dataset[datasourceName].length > 0) {
			if (dataset[datasourceName][0].QTPRGRUPROMIN > dataset[datasourceName][0].IDPRINCPRODQT)
				ScreenService.showMessage('Quantidade de produtos principais inferior a quantidade de produtos minima.');
		}
	};

	var validacoesProdutoPromocionalComposicao = function (row) {
		if (row.IDPRODPRESELEC == 'N' && row.IDOBRPRODSELEC == 'S') {
			ScreenService.showMessage(mensagens.ProdutoObrigatorio);
			return false;
		}
		if (parseFloat(row.VRDESPRODPROMOC) < 0) {
			ScreenService.showMessage(mensagens.valorDesconto);
			return false;
		}
		return true;
	};

	this.validateImprCupomField = function (widget, fieldName) {
		const parentWidget = widget.getParent().getParent();
		if (parentWidget.currentRow.IDTIPOCOMPPROD === PROMOCAO_COMBINADA_VALUE &&
			parentWidget.currentRow.IDIMPPRODUTO === '2') {
			widget.getField(fieldName).readOnly = true;
		}
		else {
			widget.getField(fieldName).readOnly = false;
		}
	};

	//---------------GRUPO PROMOCIONAL---------------------//

	//------------------INSTRUÇÕES-------------------------//

	//------------------INSTRUÇÕES-------------------------//

	//----------------COMPOSIÇÃO LOCAL---------------------//

	this.OnEnterCompLocal = function (widget) {
		widget.currentRow.CDFILIAL = templateManager.container.getWidget('PRODUTO').appliedFilter.FILTER_ROW.CDFILIAL;
		widget.currentRow.NMFILIAL = templateManager.container.getWidget('PRODUTO').appliedFilter.FILTER_ROW.NMFILIAL;
	};

	this.saveLocal = function (widget) {
		// Usado para salvar um grupo promocional de composição local
		if (widget.isValid()) {
			var row = widget.currentRow;
			row.NRORG = getLocalVar('NRORG');
			var parentRow = widget.parent.parent.parent.currentRow;

			row.CDFILIAL = templateManager.container.getWidget('TABBEDCOMPOSICAOLOCAL').currentRow.CDFILIAL;
			row.CDPRODUTO = parentRow.CDPRODUTO;

			if ((row.CDARVPROD + "").replace(/\./g, "") === (parentRow.CDARVPROD + "").replace(/\./g, "")) {
				ScreenService.showMessage(mensagens.ComposicaoRecursiva);
			}
			else {

				if (!Util.isUndefinedOrNull(row.QTSUBPRODROT)) {
					row.QTSUBPRODROT += '';
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(/\./g, '');
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(',', '.');
					row.QTSUBPRODROT = parseFloat(row.QTSUBPRODROT);
				}

				// CDPRODPROMOCAO -> Usado para salvar um produto de um grupo promocional
				if (!Util.isUndefinedOrNull(row.CDGRUPROMOC)) {
					row.CDPRODPROMOCAO = parentRow.CDPRODUTO;
					var menor = parseFloat(row.QTPRGRUPROMINFIL),
						maior = parseFloat(row.QTPRGRUPPROMFIL);
					if (!validaQuantidades(menor, maior)) return;
					///VALIDA DATA///
					if (widget.getField('DTFINVGGRPROFIL').value()) {

						if (widget.getField('DTINIVGGRPROFIL').value()) {

							if (!self.compareDates(widget.currentRow.DTINIVGGRPROFIL, widget.currentRow.DTFINVGGRPROFIL) &&
								widget.currentRow.DTINIVGGRPROFIL !== widget.currentRow.DTFINVGGRPROFIL) {
								ScreenService.showMessage(mensagens.ErroData);
							}
							else {
								General.saveCrud(widget);
							}

						}
						else {
							General.saveCrud(widget);
						}
					}
					else {
						General.saveCrud(widget);
					}

				}
				else {

					var requestRow = {
						'CDPRODUTOPAI': row.CDPRODUTO,
						'CDPRODUTOFILHO': row.CDARVPROD,
						'CDFILIAL': row.CDFILIAL
					};

					General.callRestEngine('cadEst#/checkForRecursiveComposition', 'Row', requestRow).then(function (response) {
						if (!!response.dataset.isRecursiveComposition[0]) {
							ScreenService.showMessage(mensagens.ComposicaoRecursiva);
						}
						else {
							General.saveCrud(widget);
						}
					});
				}
			}
		}
	};

	this.saveProdutoPromocionalCLocal = function (widget) {
		//Salva um Produto Promocional dentro da aba de Composição local
		var validProdPrinMax = self.validProdPrinMax(widget.currentRow);
		if (widget.isValid() && validProdPrinMax) {
			if (!validacoesProdutoPromocionalComposicaoLocal(widget.currentRow)) return;
			widget.currentRow.__is_new = Util.isUndefinedOrNull(widget.currentRow.CDPRODPROMOCAO);

			widget.currentRow.NRSEQGRPROMOFIL =
				Util.isUndefinedOrNull(widget.currentRow.NRSEQGRPROMOFIL) ? widget.getParent().currentRow.NRSEQGRPROMOFIL : widget.currentRow.NRSEQGRPROMOFIL;

			widget.currentRow.IDPERVALDESFIL =
				Util.isUndefinedOrNull(widget.currentRow.IDPERVALDESFIL) ? 'P' : widget.currentRow.IDPERVALDESFIL;
			widget.currentRow.IDOBRPRODSELFIL =
				Util.isUndefinedOrNull(widget.currentRow.IDOBRPRODSELFIL) ? 'N' : widget.currentRow.IDOBRPRODSELFIL;
			widget.currentRow.VRDESPRPROMOFIL =
				Util.isUndefinedOrNull(widget.currentRow.VRDESPRPROMOFIL) ? 0 : widget.currentRow.VRDESPRPROMOFIL;
			widget.currentRow.CDPRODPROMOCAO = widget.getParent().getParent().getParent().currentRow.CDPRODUTO;
			widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDCOMPOSICAOLOCAL').currentRow.CDFILIAL;
			General.saveCrud(widget).then(function () {
				if (!widget.currentRow.__is_new) {
					ScreenService.closeSwipe();
				}
				widget.reload().then(function (response) {
					self.validProdPrinMin(response.dataset, false);
				});
			});
		}
	};

	var validacoesProdutoPromocionalComposicaoLocal = function (row) {
		if (row.IDPRODPRESELFIL == 'N' && row.IDOBRPRODSELFIL == 'S') {
			ScreenService.showMessage(mensagens.ProdutoObrigatorio);
			return false;
		}
		if (parseFloat(row.VRDESPRPROMOFIL) < 0) {
			ScreenService.showMessage(mensagens.valorDesconto);
			return false;
		}
		return true;
	};

	//----------------COMPOSIÇÃO LOCAL---------------------//

	// ---------------------COMPOSIÇÃO---------------------------//

	// -------------------ITENS ADICIONAIS-----------------------//

	this.saveItem = function (widget) {
		//Salva um Item adicional
		if (widget.isValid) {
			widget.currentRow.CDPRODUTO = widget.getParent().currentRow.CDPRODUTO;
			General.saveCrud(widget);
		}
	};

	// -------------------ITENS ADICIONAIS-----------------------//


	this.openPopup = function (type) {
		var wdgtprod = templateManager.container.getWidget('PRODUTO');
		var filter = wdgtprod.appliedFilter;
		var popup = templateManager.container.getWidget('popupImportComp');
		popup.getField('CDPRODUTODEST').dataSourceFilter = wdgtprod.dataSourceFilter;
		popup.getField('NMPRODUTOORIG').dataSourceFilter = wdgtprod.dataSourceFilter;
		popup.getField('CDPRODUTODEST').value('');
		popup.getField('NMPRODUTOORIG').value('');
		popup.getField('NMFILIALORIG').value('');
		popup.getField('IMPORTLOCAL').value('N');
		popup.getField('IMPORTPADRAO').value('S');
		popup.getField('IDIMPORTAGRUPOLOCAL').value('N');
		popup.getField('IDIMPORTAGRUPOPADRAO').value('S');
		popup.getField('NMFILIALORIG').readOnly = true;
		popup.getField('NMFILIALORIG').validations = {};
		popup.getField('NMFILIAL').readOnly = true;
		popup.getField('NMFILIAL').validations = {};
		ScreenService.openPopup(popup);
	};

	this.changeIsNew = function (widget) {
		widget.currentRow.__is_new = false;
	};

	var self = this;

	this.importarComposicao = function (widget) {
		var NAMEWIDGET = (!widget.getField('NMFILIAL').readOnly ? 'COMPOSICAOLOCAL' : 'COMPOSICAOPADRAO');
		var wdgComp = templateManager.container.getWidget(NAMEWIDGET);
		var widgetPai = templateManager.container.getWidget('PRODUTO');
		var row = widget.currentRow;

		widgetPai.currentRow.CDFILIAL = widgetPai.dataSourceFilter[0].value;
		row.NRORG = getLocalVar('NRORG');
		if (widget.isValid()) {
			var possuiComposicaoRecursiva = false;

			// Forced array conversions
			var produtosDestino = [].concat(row.CDPRODUTODEST);

			produtosDestino.forEach(prod => {
				possuiComposicaoRecursiva = possuiComposicaoRecursiva || row.CDPRODUTOORIG === prod;
			});

			if (possuiComposicaoRecursiva) {
				ScreenService.showMessage(mensagens.ComposicaoRecursiva);
			}
			else {
				ScreenService.confirmMessage(ScreenService.i18n('Ao importar, a composição e os grupos promocionais atuais do produto destino serão sobrescritos. Confirma a operação?'), 'question', function (success) {
					var objectParam = {
						"requestType": "Row",
						"row": {
							"from": widget.currentRow
						}
					};

					var requestRow = {
						'CDPRODUTOPAI': row.CDPRODUTOORIG,
						'CDPRODUTOFILHO': produtosDestino,
						'CDFILIAL': row.CDFILIAL
					};

					General.callRestEngine('cadEst#/checkForRecursiveComposition', 'Row', requestRow).then(function (response) {
						if (!!response.dataset.isRecursiveComposition[0]) {
							ScreenService.showMessage(mensagens.ComposicaoRecursiva);
						}
						else {
							return restEngine.post(
								"cadEst#/importarComposicao", objectParam,
								undefined, undefined, undefined, undefined, 360000
							).then(function (response) {
								if (response.messages) {
									if (response.messages[1].message == 'LOCAL' && widget.currentRow.IMPORTPADRAO == 'S') {
										ScreenService.confirmMessage(ScreenService.i18n(response.messages[0].message + ' Deseja continuar?'), 'question', function (success) {
											widget.currentRow.IMPORTLOCAL = 'N';
											self.onChangeIMPORTLOCAL(widget.getField('IMPORTLOCAL'));
											self.importarComposicao(widget);
										});
									}
									else if (response.messages[1].message == 'PADRAO' && widget.currentRow.IMPORTLOCAL == 'S') {
										ScreenService.confirmMessage(ScreenService.i18n(response.messages[0].message + ' Deseja continuar?'), 'question', function (success) {
											widget.currentRow.IMPORTPADRAO = 'N';
											self.importarComposicao(widget);
										});
									}
									else if (response.messages[1]) {
										ScreenService.showMessage(response.messages[0].message, 'warning');
									}
								}
								else {
									ScreenService.closePopup();
									ScreenService.successNotification('Importação realizada com sucesso!');
									wdgComp.reload();
									widgetPai.reload();
								}
							});
						}
					});
				});
			}
		}
	};

	this.updateProdutos = function (args) {
		var field = args.owner.field;
		var widget = field.widget;
		widget.currentRow.CDPRODUTO = null;
		widget.currentRow.NMPRODUTO = null;
		widget.getField('NMPRODUTO').dataSourceFilter[0].value = widget.currentRow.CDFILIAL;
		widget.getField('NMPRODUTO').reload();
	};

	this.onChangeIMPORTLOCAL = function (field) {
		var wdgtprod = templateManager.container.getWidget('PRODUTO');
		var filter = wdgtprod.appliedFilter;
		var popup = templateManager.container.getWidget('popupImportComp');
		popup.currentRow.CDFILIAL = filter.FILTER_ROW.CDFILIAL;
		popup.currentRow.NMFILIAL = filter.FILTER_ROW.NMFILIAL;

		if (field.widget.getField('IDIMPORTAGRUPOLOCAL').value() == 'S' || field.widget.getField('IMPORTLOCAL').value() == 'S') {
			field.widget.getField('NMFILIALORIG').readOnly = false;
			field.widget.getField('NMFILIALORIG').validations = { 'required': true };
			field.widget.getField('NMFILIAL').readOnly = false;
			field.widget.getField('NMFILIAL').validations = { 'required': true };
		}
		else {
			field.widget.getField('NMFILIALORIG').readOnly = true;
			field.widget.getField('NMFILIALORIG').validations = {};
			field.widget.getField('NMFILIAL').readOnly = true;
			field.widget.getField('NMFILIAL').validations = {};
		}
		templateManager.updateTemplate();
	};

	this.getFieldValue = function (fieldName, widgetName) {
		if (templateManager.container) {
			var widget = templateManager.container.getWidget(widgetName);
			if (widget) {
				return widget.currentRow[fieldName];
			}
			else return null;
		}
		else return null;
	};

	this.exportarComposicao = function (namewidget) {
		var wdgtprod = templateManager.container.getWidget('PRODUTO');
		var filter = wdgtprod.appliedFilter;
		if (filter !== undefined) {
			var popup = templateManager.container.getWidget(namewidget);
			popup.getField('NMPRODUTODEST').dataSourceFilter = wdgtprod.dataSourceFilter;
			popup.getField('NMPRODUTODEST').value('');
			popup.getField('NMFILIALDEST').value('');
			popup.getField('IDEXPORTGRUPROMO').value('S');
			ScreenService.openPopup(popup);
		}
		else {
			ScreenService.showMessage('Favor realizar o filtro antes de exportar.');
		}
	};

	this.exportLocToLoc = function (widget) {
		var widgetPai = templateManager.container.getWidget('PRODUTO');
		var row = widget.currentRow;
		row.NRORG = getLocalVar('NRORG');

		if (widget.isValid()) {
			ScreenService.confirmMessage(ScreenService.i18n('Ao exportar, todos os itens da composição local e seus grupos promocionais locais serão sobrescritos. Confirma a operação?'), 'question', function (success) {
				var objectParam = {
					"requestType": "Row",
					"row": {
						"from": widget.currentRow
					}
				};

				/*var requestRow = {
					'CDFILIALORIG': row.CDFILIALORIG,
					'CDFILIAL': row.CDFILIALDEST,
					'CDPRODUTOS': row.CDPRODUTODEST,
					'IDEXPORTGRUPROMO': row.IDEXPORTGRUPROMO,
					'NRORG': row.NRORG
				};*/

				return restEngine.post("cadEst#/exportCompLocLoc", objectParam, undefined, undefined, undefined, undefined, 360000)
					.then(function () {
						ScreenService.closePopup();
						ScreenService.showMessage('Exportação realizada com sucesso!');
						widgetPai.reload();
					});
			});
		}
	};

	this.exportPadrToLoc = function (widget) {
		var widgetPai = templateManager.container.getWidget('PRODUTO');
		var row = widget.currentRow;
		row.NRORG = getLocalVar('NRORG');

		if (widget.isValid()) {
			ScreenService.confirmMessage(ScreenService.i18n('Ao exportar, todos os itens da composição local e seus grupos promocionais locais serão sobrescritos. Confirma a operação?'), 'question', function (success) {
				var objectParam = {
					"requestType": "Row",
					"row": {
						"from": widget.currentRow
					}
				};

				var requestRow = {
					'CDFILIAL': row.CDFILIALDEST,
					'CDPRODUTOS': row.CDPRODUTODEST,
					'IDEXPORTGRUPROMO': row.IDEXPORTGRUPROMO,
					'NRORG': row.NRORG
				};

				return restEngine.post("cadEst#/exportCompPadrLoc", objectParam, undefined, undefined, undefined, undefined, 360000)
					.then(function () {
						ScreenService.closePopup();
						ScreenService.showMessage('Exportação realizada com sucesso!');
						widgetPai.reload();
					});
			});
		}
	};

	this.exportLocToPadr = function (widget) {
		var widgetPai = templateManager.container.getWidget('PRODUTO');
		var row = widget.currentRow;
		row.NRORG = getLocalVar('NRORG');

		if (widget.isValid()) {
			ScreenService.confirmMessage(ScreenService.i18n('Ao exportar, todos os itens da composição Padrão e seus grupos promocionais padrões serão sobrescritos. Confirma a operação?'), 'question', function (success) {
				var objectParam = {
					"requestType": "Row",
					"row": {
						"from": widget.currentRow
					}
				};

				var requestRow = {
					'CDFILIAL': row.CDFILIAL,
					'CDPRODUTOS': row.CDPRODUTODEST,
					'IDEXPORTGRUPROMO': row.IDEXPORTGRUPROMO,
					'NRORG': row.NRORG
				};

				return restEngine.post("cadEst#/exportCompLocPadr", objectParam, undefined, undefined, undefined, undefined, 360000)
					.then(function () {
						ScreenService.closePopup();
						ScreenService.showMessage('Exportação realizada com sucesso!');
						widgetPai.reload();
					});
			});
		}
	};

	this.onEnterProdutoGrupoPromo = function (args) {
		var widget = args.owner;
		widget.dataSourceFilter = [{
				"name": "CDPRODPROMOCAO",
				"operator": "=",
				"value": General.getFieldValue('CDPRODUTO', 'PRODUTO')
			},
			{
				"name": "CDGRUPROMOC",
				"operator": "=",
				"value": General.getFieldValue('CDGRUPROMOC', 'GRUPOPROMOCIONAL')
			},
			{
				"name": "NRSEQGRPROMO",
				"operator": "=",
				"value": General.getFieldValue('NRSEQGRPROMO', 'GRUPOPROMOCIONAL')
			}
		];
		widget.reload();
	};

	this.editGrupoPromocionalPadrao = function (args) {
		var widget = args.owner.widget;
		args.owner.widget.currentRow.IDPRINCPRODBKP = args.owner.widget.currentRow.IDPRINCPROD;
		General.edit(args.owner.widget);

		this.setValidationValuePadrao(widget);
		if (widget.currentRow.IDPERVALORDES == null || widget.currentRow.IDDESCACRPROMO == null) {
			widget.currentRow.__is_new = true;
		}
		else {
			widget.currentRow.__is_new = false;
		}

	};

	this.editGrupoPromocionalLocal = function (args) {
		var widget = args.owner.widget;
		args.owner.widget.currentRow.IDPRINCPRODBKP = args.owner.widget.currentRow.IDPRINCPROD;
		General.edit(args.owner.widget);

		this.setValidationValue(widget);
		if (widget.currentRow.IDDESCACRPROFIL == null ||
			widget.currentRow.IDPERVALDESFIL == null) {
			widget.currentRow.__is_new = false;
		}
		else {
			widget.currentRow.__is_new = true;
		}

	};

	var requestModulesMetadata = function () {
		var modulesPackage = window.modulesPackage || "modules";
		return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
			return response.data;
		});
	};
	this.voltarDashboard = function () {
		this.openWindow('product#dashboard');
	};

	this.openWindow = function (windowName, newWindow) {
		requestModulesMetadata().then(function (modules) {
			var subModule = windowName.split('#')[0];
			var module = subModule.split('_')[0];
			var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
			if (ScreenService.openLink) {
				ScreenService.openLink(url, newWindow);
			}
			else {
				ScreenService.openWindow(windowName);
			}
		});
	};


	this.tornarVisivelCobrarItem = function (widget) {
		widget.getField("IDCOBRAADIC").isVisible = (widget.getField('IDMODOVENDA').value() === 'TGO');
		templateManager.updateTemplate();
		if (widget.getField('IDMODOVENDA').value() !== 'TGO') {
			widget.getField('IDCOBRAADIC').value('S');
		}
	};

	this.setDatafinLocalObrigatoria = function (widget) {
		if (widget.currentRow.DTINIVGGRPROFIL) {
			widget.getField('DTFINVGGRPROFIL').validations = {
				"required": {
					"message": "Campo Obrigatorio"
				}
			};
		}
		else {
			widget.getField('DTFINVGGRPROFIL').validations = {};
		}
		templateManager.updateTemplate();
	};
	this.setDatafinObrigatoria = function (widget) {
		if (widget.currentRow.DTINIVGGRPROMO) {
			widget.getField('DTFINVGGRPROMO').validations = {
				"required": {
					"message": "Campo Obrigatorio"
				}
			};
		}
		else {
			widget.getField('DTFINVGGRPROMO').validations = {};
		}
		templateManager.updateTemplate();
	};

	this.validateDateLocal = function (field) {
		var widget = field.widget;

		if (!self.compareDates(widget.currentRow.DTINIVGGRPROFIL, widget.currentRow.DTFINVGGRPROFIL) || widget.currentRow.DTINIVGGRPROFIL == widget.currentRow.DTFINVGGRPROFIL) {
			ScreenService.showMessage(mensagens.ErroData);
			field.clearValue(field);
		}
	};

	this.compareDates = function (minorDate, majorDate) {
		var small = new Date(moment(minorDate, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();
		var big = new Date(moment(majorDate, 'DD/MM/YYYY').format('YYYY,MM,DD')).getTime();
		return (small <= big);
	};


	this.addProdInGroupPromo = function (args) {
		var widget = args.owner.widget;
		widget.getField('NMPRODUTO').readOnly = false;
		widget.currentRow.CDGRUPROMOC = widget.getParent().currentRow.CDGRUPROMOC;
		widget.newRow();
	};
	///CADASTRO AUTOMATICO LOCAL INICIO/////
	this.openPopupAlteracaoAutomaticaLocal = function () {
		var widgetAlteracao = templateManager.container.getWidget('alteracaoAutomaticaLocalPrecosPopup');
		widgetAlteracao.currentRow = {};
		var row = widgetAlteracao.currentRow;

		widgetAlteracao.list();

		row.CDFILIAL = General.getFieldValue('CDFILIAL', 'TABBEDCOMPOSICAOLOCAL');
		row.IDAPLICADESCFIL = 'N';
		row.IDIMPGRPROMOFIL = 'N';
		self.setDatafinLocalObrigatoria(widgetAlteracao);
		ScreenService.openPopup(widgetAlteracao);
	};
	///CADASTRO AUTOMATICO LOCAL FIM/////

	///CADASTRO AUTOMATICO INICIO/////
	this.openPopupAlteracaoAutomatica = function () {
		var widgetAlteracao = templateManager.container.getWidget('alteracaoAutomaticaPrecosPopup');
		widgetAlteracao.currentRow = {};
		var row = widgetAlteracao.currentRow;

		widgetAlteracao.list();

		row.CDFILIAL = General.getFieldValue('CDFILIAL', 'TABBEDCOMPOSICAOLOCAL');
		row.IDAPLICADESC = 'N';
		row.IDIMPGRPROMO = 'N';

		self.setDatafinObrigatoria(widgetAlteracao);
		ScreenService.openPopup(widgetAlteracao);
	};

	this.setProdFinalPopup = function (args, fieldProdFin) {
		var field = args.owner.field;
		var row = field.widget.currentRow;
		var fieldFinal = field.widget.getField(fieldProdFin);

		fieldFinal.validations = { required: true };
		fieldFinal.readOnly = false;

		row[fieldProdFin] = row.NMPRODUTOINI;
		row.CDPRODUTOFIN = field.widget.currentRow.CDPRODUTOINI;
		row.CDARVPRODFIN = field.widget.currentRow.CDARVPRODINI;

		if (field.value()) {
			fieldFinal.readOnly = false;

			self.verificaFiltro(fieldFinal);

			fieldFinal.dataSourceFilter[6] = {
				"name": "CDARVPROD",
				"operator": ">=",
				"value": row.CDARVPRODINI
			};

			field.validations = { required: true };
			fieldFinal.validations = { required: true };
			fieldFinal.reload();
		}
		else {
			delete fieldFinal.validations;
			fieldFinal.readOnly = true;
		}
	};

	var saveAltAuto = function (widget) {
		const widgetGrupoPromo = widget.name === 'alteracaoAutomaticaLocalPrecosPopup' ?
			templateManager.container.getWidget('GRUPOPROMOCIONALLOCAL') :
			templateManager.container.getWidget('GRUPOPROMOCIONAL');

		General.saveCrud(widget).then(
			function () {
				widget.currentRow.changed = false;
				widget.currentRow.__is_new = false;
				widget.currentRow = {};
				ScreenService.closePopup();
				ScreenService.closePopup();
				widgetGrupoPromo.activate();
				widgetGrupoPromo.reload().then(function () {
					self.gpPromoOnEnter(widgetGrupoPromo);
				});
			});
	};

	this.AltAuto = function (widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			row.NRORG = getLocalVar('NRORG');
			var parentRow = widget.getParent().getParent().currentRow;
			// CDPRODUTO -> Usado para salvar um grupo de composição
			row.CDPRODUTO = parentRow.CDPRODUTO;

			if ((row.CDARVPROD + "").replace(/\./g, "") === (parentRow.CDARVPROD + "").replace(/\./g, "")) {
				ScreenService.showMessage(mensagens.ComposicaoRecursiva);
			}
			else {
				if (!Util.isUndefinedOrNull(row.QTSUBPRODROT)) {
					row.QTSUBPRODROT += '';
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(/\./g, '');
					row.QTSUBPRODROT = row.QTSUBPRODROT.replace(',', '.');
					row.QTSUBPRODROT = parseFloat(row.QTSUBPRODROT);
				}

				// CDPRODPROMOCAO -> Usado para salvar um produto de um grupo promocional
				if (!Util.isUndefinedOrNull(row.CDGRUPROMOC)) {
					row.CDPRODPROMOCAO = parentRow.CDPRODUTO;
					var menor = parseFloat(row.QTPRGRUPROMIN),
						maior = parseFloat(row.QTPRGRUPPROMOC);
					if (!validaQuantidades(menor, maior)) return;
					///VALIDA DATA////
					if (widget.getField('DTFINVGGRPROMO').value()) {
						if (widget.getField('DTINIVGGRPROMO').value()) {
							if (!self.compareDates(widget.currentRow.DTINIVGGRPROMO, widget.currentRow.DTFINVGGRPROMO) &&
								widget.currentRow.DTINIVGGRPROMO !== widget.currentRow.DTFINVGGRPROMO) {
								ScreenService.showMessage(mensagens.ErroData);
							}
							else {
								saveAltAuto(widget);
							}
						}
						else {
							saveAltAuto(widget);
						}
					}
					else {
						saveAltAuto(widget);
					}
				}
				else {
					var parentWidget = widget.getParent().getParent();

					var requestRow = {
						'CDPRODUTOPAI': parentWidget.currentRow.CDPRODUTO,
						'CDPRODUTOFILHO': row.CDARVPROD,
						'CDFILIAL': parentWidget.appliedFilter.FILTER_ROW.CDFILIAL
					};

					General.callRestEngine('cadEst#/checkForRecursiveComposition', 'Row', requestRow).then(function (response) {
						if (!!response.dataset.isRecursiveComposition[0]) {
							ScreenService.showMessage(mensagens.ComposicaoRecursiva);
						}
						else {
							General.saveCrud(widget).then(function () {
								widget.currentRow.changed = false;
							});
						}
					});
				}
			}
		}
	};

	this.AltAutoFil = function (widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			row.NRORG = getLocalVar('NRORG');
			var parentRow = widget.getParent().getParent().currentRow;
			// CDPRODUTO -> Usado para salvar um grupo de composição
			row.CDPRODUTO = parentRow.CDPRODUTO;

			if ((row.CDARVPROD + "").replace(/\./g, "") === (parentRow.CDARVPROD + "").replace(/\./g, "")) {
				ScreenService.showMessage(mensagens.ComposicaoRecursiva);
			}
			else {
				// CDPRODPROMOCAO -> Usado para salvar um produto de um grupo promocional
				row.CDPRODPROMOCAO = parentRow.CDPRODUTO;

				var menor = parseFloat(row.QTPRGRUPROMINFIL),
					maior = parseFloat(row.QTPRGRUPPROMFIL);
				if (!validaQuantidades(menor, maior)) return;
				///VALIDA DATA////
				if (widget.getField('DTFINVGGRPROFIL').value()) {
					if (widget.getField('DTINIVGGRPROFIL').value()) {
						if (!self.compareDates(widget.currentRow.DTINIVGGRPROFIL, widget.currentRow.DTFINVGGRPROFIL) &&
							widget.currentRow.DTINIVGGRPROFIL !== widget.currentRow.DTFINVGGRPROFIL) {
							ScreenService.showMessage(mensagens.ErroData);
						}
						else {
							saveAltAuto(widget);
						}
					}
					else {
						saveAltAuto(widget);
					}
				}
				else {
					saveAltAuto(widget);
				}
			}
		}
	};
	this.checkVigIsRequired = function (field, local) {
		var DTINIVG, DTFINVG, CDGRUPRO;
		if (local) {
			DTINIVG = 'DTINIVGGRPROFIL';
			DTFINVG = 'DTFINVGGRPROFIL';
			CDGRUPRO = 'CDGRUPROMOC';
		}
		else {
			DTINIVG = 'DTINIVGGRPROMO';
			DTFINVG = 'DTFINVGGRPROMO';
			CDGRUPRO = 'CDGRUPROMOC';
		}
		if (field.currentRow.ISVIGREQUIRED) {
			field.getField(DTFINVG).validations = {
				"required": {
					"message": "Campo Obrigatorio"
				}
			};
			field.getField(DTINIVG).validations = {
				"required": {
					"message": "Campo Obrigatorio"
				}
			};
		}
		else {
			field.getField(DTFINVG).validations = {};
			field.getField(DTINIVG).validations = {};
		}
		templateManager.updateTemplate();
	};

	////CADASTRO AUTOMATICO FIM/////
	this.gpPromoOnEnter = function (widget) {
		if (widget.dataSource.data.length === 0) {
			widget.getAction('altAutPreco').isVisible = false;
		}
		else {
			widget.getAction('altAutPreco').isVisible = true;
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger14600_ComposicaoDoProduto_Controller', Ger14600_ComposicaoDoProduto_Controller);
});
