function ger10000_segmento_de_mercadoController(ScreenService, Ger10000_SegmentoDeMercado_Service, General, templateManager) {
	this.saveSegmento = function (widget) {
		if (widget.isValid()){
			widget.saveRow().then(function (callback) {
				var currentRow = widget.currentRow;
				currentRow.__is_new = false;
				currentRow.changed = false;
				widget.reload().then(function () {
					ScreenService.closeSwipe();
					widget.list();
				});
			}, function (callback) {
				ScreenService.showMessage(callback.data.error);
			});
		}

	};

	this.delete = function (widget) {

		widget.removeCheckedRows().then(function (callback) {
			var currentRow = widget.currentRow;
			currentRow.__is_new = false;
			currentRow.changed = false;
			widget.reload().then(function () {
				ScreenService.closeSwipe();
				widget.list();
			});
		}, function (callback) {
			ScreenService.showMessage("Não é possivel deletar!Existem um ou mais registros filhos.");
		});

	};
	
	this.saveProdutosSegmento = function(widget){
		var row = widget.currentRow;
		
		Ger10000_SegmentoDeMercado_Service.saveProdutosSegmento(row).then(function (callback){
			widget.currentRow.__is_new = false;
			widget.currentRow.changed = false;
			widget.reload().then(function () {
				ScreenService.closeSwipe();
				widget.list();
			});
		}, function (callback) {
			ScreenService.showMessage(callback.data.error);
		});
	};
	
	this.deleteProdutosSegmento = function(widget){
		const row = widget.currentRow;
		const afterDelete = (widget)=>{
        	widget.currentRow.__is_new = false;
			widget.currentRow.changed = false;
			ScreenService.closeSwipe();
			widget.list();
			widget.reload();
        };
        
		row.CDFILIAL = getLocalVar('CDFILIAL');
		
		ScreenService.confirmMessage(ScreenService.i18n('Deletar registro?'), 'question', function(success) {
			row.PRICECHECK = false;
            Ger10000_SegmentoDeMercado_Service.deleteProdutosSegmento(row).then(function (callback){
				afterDelete(widget);
			}, function (callback) {
				if(callback.data.error == 'Exception: Produto(s) com preço cadastrado.'){
					ScreenService.confirmMessage(ScreenService.i18n('Produto(s) com preço cadastrado. Deseja continuar?'), 'question', success=> {
						row.PRICECHECK = true;
						Ger10000_SegmentoDeMercado_Service.deleteProdutosSegmento(row).then(function (callback){
							afterDelete(widget);
						});
					});
				}else{
					ScreenService.showMessage(callback.data.error);
				}
			});
        });
	};
	
	this.updateProdAtivo = function(widget) {
        var rows = widget.dataSource.data;
        rows = rows.filter(function(row){
            return row.changed === true && !row.__is_new;
        });
        rows.forEach(function(row) {
            var rowItem = row;
            rowItem.IDPROSEGATIV = rowItem.IDPROSEGATIV_inline || rowItem.IDPROSEGATIV;
            delete rowItem.IDPROSEGATIV_inline;
        });
        Ger10000_SegmentoDeMercado_Service.updateProdAtivo(rows).then(function(response){
        	widget.list();
        	widget.reload();
        });
        
        widget.list();
    };

	this.changeWidgetAcessibility = function(widget, flag = false){
		General.changeWidgetAcessibility(widget.widgets, flag);
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger10000_segmento_de_mercadoController', ger10000_segmento_de_mercadoController);
});