var ger15300_agrupamento_unidade_controller = function(General, ScreenService, templateManager) {

    this.filterWidgetsAgrupamento = function(widget) {
        widget.widgets.forEach(function(w){
            w.dataSourceFilter = [
                {
                    name: "CDGRUPFILI",
                    operator: "=",
                    value: widget.currentRow.CDGRUPFILI
                }
            ];
        });
    };

    this.filterWidgetsTab = function(args) {
        var outerWidget = args.owner;
        var groupWidget = outerWidget.getParent().currentRow.CDGRUPFILI;

        outerWidget.dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": groupWidget
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORGTRAB')
            }
        ];

        outerWidget.reload();
    };

    this.filterWidgetsSelect = function(args) {
        var outerWidget = args.owner.field;
        var groupWidget = outerWidget.widget.getParent().currentRow.CDGRUPFILI;

        outerWidget.dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "operator": "<>",
                "value": groupWidget
            }
        ];

        outerWidget.reload();
    };

    this.ger15300_agrupamento_unidade_controllerActionEventCancel = function(args) {
		var widget = args.owner.widget;

		General.widgetCancelForm(widget);
	};

    this.ger15300_agrupamento_unidade_controllerActionEventEdit = function(args) {
	    var widget = args.owner.widget;

        General.widgetEdit(widget);

	};

    this.ger15300_agrupamento_unidade_controllerActionEventNew = function(args) {

        var widget = args.owner.widget;
        General.widgetNewRow(widget);
    };

    this.ger15300_agrupamento_unidade_controllerActionEventSaveTab = function(args) {

        var widget = args.owner.widget;
        widget.currentRow.CDGRUPFILI = widget.getParent().currentRow.CDGRUPFILI;

        General.saveCrud(widget).then(function(success){
            ScreenService.successNotification('Salva com sucesso!');
            General.changeWidgetAcessibility(widget.getParent().widgets, true);
        });
    };

    this.ger15300_agrupamento_unidade_controllerActionEventSave = function(args) {

        var widget = args.owner.widget;

        if (getValidCD(widget.currentRow.CDGRUPFILI, 10) !== null){
            widget.currentRow.CDGRUPFILI = getValidCD(widget.currentRow.CDGRUPFILI, 10);
            
            General.saveCrud(widget).then(function(callback){
                ScreenService.successNotification('Salva com sucesso!');
                General.changeWidgetAcessibility(widget.widgets, true);
            });
    
        }
    };

    this.ger15300_agrupamento_unidade_controllerActionEventDeleteTab = function(args) {

        var widget = args.owner.widget;
        widget.currentRow.CDGRUPFILI = widget.getParent().currentRow.CDGRUPFILI;

        General.deleteCrud(widget).then(function(success){
            ScreenService.successNotification('Deletado com sucesso!');

        });

        widget.reload();
    };

    this.ger15300_agrupamento_unidade_controllerActionEventDelete = function(args) {

        var widget = args.owner.widget;

        General.deleteCrud(widget).then(function(success){
            ScreenService.successNotification('Deletado com sucesso!');

        });

        widget.reload();
    };

    var getValidCD = function(check, sizeOfColumn) {
        check = check+'';
		if (check !== null) {

			var repeatZero = sizeOfColumn - check.length;
			var regex = /^[0-9]+$/g;
			regex.test(regex, sizeOfColumn.toString());
			return regex.test(check) ? ('0'.repeat(repeatZero) + check) : null;

		} else {

			return null;
		}
	};

};

Configuration(function(ContextRegister) {
    ContextRegister.register('ger15300_agrupamento_unidade_controller', ger15300_agrupamento_unidade_controller);
});