function ger01700_unidade_repository(restEngine) {
    var self = this;

    /* **************************************************
     * Função que requisita a atualização dos produtos de
     * uma filial.
     *
     * @param string CDFILIAL
     * @param number CDNVPRODUTO
     *
     * @return Promise
     */
    self.requestAtualizaProduto = function(CDFILIAL, CDNVPRODUTO) {
        return restEngine.post("cadEst#/atualizaProduto", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "P_CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                },
                {
                    name: "P_CDNVPRODUTO",
                    operator: "=",
                    value: CDNVPRODUTO
                }
            ]
        }, undefined, undefined, undefined, undefined, 8001000); //the timeout limit É MAIS DE OITO MIL!!!11!1
    };

    /* **************************************************
     * Função que requisita a validação de endereço.
     *
     * @param string CDFILIAL
     *
     * @return Promise
     */
    self.requestEndefiliValidation = function(CDFILIAL) {
        return restEngine.post("cadEst#/endefili_validation", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "P_CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                }
            ]
        });
    };

    /* **************************************************
     * Função que requisita as validações de Paramgeral.
     *
     * @return Promise
     */
    self.requestParametrizacaoValidation = function() {
        return restEngine.post("cadEst#/paramgeral_paramfilipadr_validation", {
            "requestType": "FilterData",
            "filter": []
        });
    };

    /* **************************************************
     * Função que requisita as validações da PK de uma
     * Unidade.
     *
     *  @param string CDFILIAL
     *
     * @return Promise
     */
    self.requestUnidadeCodeValidation = function(CDFILIAL) {
        return restEngine.post("cadEst#/unidade_code_check", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "P_CDFILIAL",
                    operator: "=",
                    value: CDFILIAL
                }
            ]
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ger01700_unidade_repository', ger01700_unidade_repository);
});