function ProductField(templateManager) {
    const isUserFiltering = ({selectWidget: widget}) => !!widget.filterApplied.length;

    const updateInnerWidgetExhibitionMode = ({selectWidget: widget}, mode) => {
        const treeModifier = mode === 'tree'? 'tree/' : '';

        widget.template = `widget/${treeModifier}grid.html`;

        return templateManager.updateTemplate();
    };

    //Tree behavior blocked, waiting Zeedhi Framework to become faster
    this.updateExhibitionMode = field => {
        const mode = 'grid'; //isUserFiltering(field)? 'grid' : 'tree';

        field.showSelectAs = mode;

        return updateInnerWidgetExhibitionMode(field, mode).then(() => mode);
    };

    this.updateProductFilters = widget => {
        const fields = widget.fields.filter(field => field.label.startsWith('Produto'));
        const {CDFILIAL} = widget.currentRow;


        //switch to updateSelectFieldFilialFilter when Zeedhi Framework manage to become faster
        fields.forEach(removeSelectFieldFilialFilter);
    };

    const isFilterable = field => field.template.includes("select") &&
                                 !field.template.includes("native") &&
                                !!field.dataSourceFilter;

    const removeSelectFieldFilialFilter = field => {
        if(isFilterable(field)) {
            field.dataSourceFilter = field.dataSourceFilter.filter(filter => filter.name != 'CDFILIAL');
            field.reload();
        }
    };

    const updateSelectFieldFilialFilter = field => {
        if(isFilterable(field)) {
            field.dataSourceFilter.find(filter => filter.name == 'CDFILIAL').value = CDFILIAL;
            field.reload();
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProductField', ProductField);
});
